*
      SUBROUTINE CAZ_TRSV(NAME, N, NPROW, NPCOL, AMEM, MEMSIZE, NB,
     $                    INFILED, INFILEDL, INFILEDU, INFILEB,OUTFILE)
*
*      PZDTSV, PZPTSV
*
      include 'mpif.h'
*
*  
      INTEGER            N, NPROW, NPCOL, NB, MEMSIZE
      DOUBLE COMPLEX     AMEM( MEMSIZE )
      CHARACTER*(*)      INFILED, INFILEDL, INFILEDU, INFILEB,
     $                   OUTFILE, NAME
*
*   -  
      INTEGER            NOUT, NIN, NPR
      PARAMETER          ( NOUT =13, NIN = 11, NPR = 6 )
*
*  
      INTEGER            CTXT, I, IAM, INFO, IPB, IPX, IPW,
     $                   IPWOR, IPD, IPDL, IPDU, IPE,
     $                   MYCOL, MYROW, NPROCS,
     $                   NP, NQ, NQRHS, NRHS, LWORK,
     $                   IA, JA, IB, JB, IX, JX,
     $                   MMIN, WORKSIZ
*
*  
      INTEGER            DESCA(7), DESCB(7), DESCAK(9), DESCBK(9)
*
      CHARACTER*(*)      UPLO
      PARAMETER          ( UPLO = 'U' )
*
*  
      INTEGER            ICEIL, NUMROC
      EXTERNAL           ICEIL, NUMROC
*
*  
      EXTERNAL           BLACS_EXIT, BLACS_GET, BLACS_GRIDEXIT,
     $                   BLACS_GRIDINFO, BLACS_GRIDINIT, BLACS_PINFO,
     $                   BLACS_SETUP, DESCINIT, PZLAPRNT, PZLAREAD,
     $                   PZLAWRITE,
     $                   PZDTSV, PZPTSV
*
*  
*
*  
*
**      NPROCS = NPROW*NPCOL
      IA = 1
      JA = 1
      IB = 1
      JB = 1
      NRHS = 1
*
*   BLACS
*
      CALL BLACS_PINFO( IAM, NPROCS )
*
        IF( NPROCS.LT.1 ) THEN
           CALL BLACS_SETUP( IAM, NPROCS )
**           CALL BLACS_SETUP( IAM, NPROW*NPCOL )
        END IF
*
*   BLACS'   
*
      CALL BLACS_GET( -1, 0, CTXT )
      CALL BLACS_GRIDINIT( CTXT, 'R', NPROW, NPCOL )
      CALL BLACS_GRIDINFO( CTXT, NPROW, NPCOL, MYROW, MYCOL )
*
*       ,
*    
*
      IF( MYROW.GE.NPROW .OR. MYCOL.GE.NPCOL ) GO TO 20
*
      INFO = 0
*
*      A, B, AK    BK
*
      DESCA(1) = 501
      DESCA(2) = CTXT
      DESCA(3) = N
      DESCA(4) = NB
* CSRC
      DESCA(5) =0
* LLD_A,   = 0
      DESCA(6) = 0
      DESCA(7) = 0
*
      DESCB(1) = 502
      DESCB(2) = CTXT
      DESCB(3) = N
      DESCB(4) = NB
* RSRC
      DESCB(5) = 0
* LLD_B
      DESCB(6) = NB
      DESCB(7) = 0
*
      CALL DESCINIT( DESCBK, 1, N, 1, NB, 0, 0, CTXT, 1, INFO )
*
*      ( DL, D, DU )
*  (AK,BK-   A,B)
      CALL DESCINIT( DESCAK, 1, N, 1, NB, 0, 0, CTXT, 1, INFO)
*
      NP = 1
*      NQ = NB
*      NQRHS = NUMROC( NRHS, NB, MYCOL, 0, NPCOL ) = NB
*
*    ( MMIN )
*
*     AMEM
*
      IPDL = 0
      IPD = 0
      IPDU = 0
      IPE = 0
*                                   
*    ()   B
      IPB = 1
*
      IF( NAME .NE. 'PZDTSV' ) GOTO 1
*
*   ,    PZDTSV
      LWORK = (12*NPCOL + 3*NB) +
     $        MAX(10*NPCOL + 4*NRHS, 8*NPCOL)
*
*       
      IPDL = IPB + NB*NRHS
      IPD = IPDL + NB
      IPDU = IPD + NB
      IPWOR = IPDU + NB
*
      GO TO 3
*
    1 IF( NAME .NE. 'PZPTSV' ) GOTO 10
*
*   ,    PZPTSV
      LWORK = (12*NPCOL + 3*NB) +
     $        MAX((10 + 2*MIN(100,NRHS))*NPCOL + 4*NRHS, 8*NPCOL)
*
*      
*  
      IPD = IPB + NB*NRHS
      IPE = IPD + NB
      IPWOR = IPE + NB
***
    3 IPW = IPWOR + LWORK
*
*     PZLAPRNT  .
*
      WORKSIZ = MAX( NB, NP )
*
*        
      MMIN = IPW + WORKSIZ
*
*      NPROCS = NPROCS1
*
*      ( MMIN )
*
      IF(IPW + WORKSIZ .GT. MEMSIZE ) THEN
         IF( IAM .EQ. 0 ) WRITE( NPR, FMT = * )'  '
         OPEN( NOUT, FILE = OUTFILE, STATUS = 'UNKNOWN' )
         IF( IAM .EQ. 0 ) WRITE( NOUT, FMT = * )'  '
         INFO = 1
      END IF
*
*   INFO    
*
      CALL IGSUM2D( CTXT, 'All', ' ', 1, 1, INFO, 1, -1, 0 )
      IF( INFO .GT. 0 ) THEN
         OPEN( NOUT, FILE = OUTFILE, STATUS = 'UNKNOWN' )
         IF( IAM .EQ. 0 )
     $       WRITE( NOUT, FMT = * ) '   '
         GO TO 10
      END IF
*
*   
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
       WRITE( NPR, FMT = 9992 )NAME
       WRITE( NPR, FMT = 9998 )N, N, NB
       WRITE( NPR, FMT = 9997 )NPROW*NPCOL, NPROW, NPCOL
       WRITE( NPR, FMT = * )'   IPB,   IPWOR,  IPW,  MMIN'
       WRITE( NPR, FMT = 9994 )IPB, IPWOR,  IPW, MMIN
       WRITE( NPR, FMT = * )'   IPDL,  IPD,    IPDU,  IPE'
       WRITE( NPR, FMT = 9994 )IPDL, IPD, IPDU,  IPE
*
       WRITE( NPR, FMT = 9991 )LWORK
       WRITE( NPR, FMT = * ) '  DESCA'
       WRITE( NPR, FMT = 9985 )DESCA  
       WRITE( NPR, FMT = * ) '  DESCB'
       WRITE( NPR, FMT = 9985 )DESCB  
       WRITE( NPR, FMT = * ) '  DESCAK'
       WRITE( NPR, FMT = 9985 )DESCAK  
       WRITE( NPR, FMT = * ) '  DESCBK'
       WRITE( NPR, FMT = 9985 )DESCBK  
       WRITE( NPR, FMT = * ) '  A'
      END IF
*
*        A(DL,D,DU)  B
*
      IF( NAME .NE. 'PZDTSV' ) GOTO 16
      CALL PZLAREAD( INFILED, AMEM(IPD), DESCAK, 0, 0, AMEM(IPW) )
      CALL PZLAREAD( INFILEDU, AMEM(IPDU), DESCAK, 0, 0, AMEM(IPW) )
      CALL PZLAREAD( INFILEDL, AMEM(IPDL), DESCAK, 0, 0, AMEM(IPW) )
      GO TO 9
*
   16 IF( NAME .NE. 'PZPTSV' ) GOTO 10
      CALL PZLAREAD( INFILED, AMEM(IPD), DESCAK, 0, 0, AMEM(IPW) )
      CALL PZLAREAD( INFILEDU, AMEM(IPE), DESCAK, 0, 0, AMEM(IPW) )
      GO TO 9
*
 9991 FORMAT( /'LWORK =' I5 //)
 9994 FORMAT( / 5I7 //)
 9985 FORMAT( / 9I5 /)
*
    9 CALL PZLAREAD( INFILEB, AMEM(IPB), DESCBK, 0, 0, AMEM(IPW))
*
*    A(DL,D,DU)  B
*
      IF( NAME .NE. 'PZDTSV' ) GOTO 17
*
      CALL PZLAPRNT( 1, N, AMEM(IPDU), IA, JA, DESCAK, 0, 0,'DU',
     $              NPR, AMEM( IPW ) )
      CALL PZLAPRNT( 1, N, AMEM(IPD), IA, JA, DESCAK, 0, 0, 'D',
     $               NPR, AMEM( IPW ) )
      CALL PZLAPRNT( 1, N, AMEM(IPDL), IA, JA, DESCAK, 0, 0,'DL',
     $              NPR, AMEM( IPW ) )
      GO TO 19
*
   17 IF( NAME .NE. 'PZPTSV' ) GOTO 10
*
      CALL PZLAPRNT( 1, N, AMEM(IPD), IA, JA, DESCAK, 0, 0, 'D',
     $               NPR, AMEM( IPW ) )
      CALL PZLAPRNT( 1, N, AMEM(IPE), IA, JA, DESCAK, 0, 0, 'E',
     $               NPR, AMEM( IPW ) )
      GO TO 19
*
   19 IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NPR, FMT = * ) '  B'
      END IF
*
      CALL PZLAPRNT( NRHS, N, AMEM(IPB), IB, JB, DESCBK, 0, 0, 'B',
     $               NPR, AMEM( IPW ) )
*
*    A * X = B
*
      IF( NAME .EQ. 'PZDTSV' ) GOTO 14
      IF( NAME .EQ. 'PZPTSV' ) GOTO 15
      GO TO 10
*
   14 CALL PZDTSV( N, NRHS, AMEM(IPDL),AMEM(IPD),AMEM(IPDU), JA, DESCA,
     $             AMEM(IPB), IB, DESCB, AMEM(IPWOR), LWORK, INFO )
      GOTO 99
*
   15 CALL PZPTSV( UPLO, N, NRHS, AMEM(IPD), AMEM(IPE), JA, DESCA,
     $             AMEM(IPB), IB, DESCB, AMEM(IPWOR), LWORK, INFO )
      GOTO 99
*
*   X
*
   99 IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NPR, FMT = * ) '  '
         WRITE( NPR, FMT = 9996 )INFO
         WRITE( NPR, FMT = * ) '   X'
      END IF
*
      CALL PZLAPRNT(NRHS, N, AMEM(IPB), IB, JB, DESCBK, 0, 0, 'X', NPR,
     $              AMEM( IPW ) )
*
*     
*
      CALL PZLAWRITE( OUTFILE, NRHS, N, AMEM(IPB), 1, 1, DESCBK,
     $                0, 0, AMEM(IPW) )
*
   10 CONTINUE
*
      CALL BLACS_GRIDEXIT( CTXT )
   20 CONTINUE
*
      IF( IAM .EQ. 0 ) THEN
         IF( NOUT .NE. 6 .AND. NOUT .NE. 0 ) CLOSE( NOUT )
      END IF
*
      CALL BLACS_EXIT( 0 )
*
 9992 FORMAT( / '    ', A7 )
 9998 FORMAT(/'  A X = B ,'//,
     $      '  A -   ',I2,' ',I2,',',
     $       /'        ( )',
     $       ' NB = ',I2 //)
*
 9997 FORMAT( / '   ', I2, ' ,',
     $       '    ', I2, '  ', I2,
     $       // '     ' /)
 9996 FORMAT( / '  INFO  = ', I6 /)
*
      RETURN
      END
